CodeForces

Permutation p is an ordered set of integers p1,  p2,  ...,  pn, consisting of n distinct positive integers, each of them doesn't exceed n. We'll denote the i-th element of permutation p as pi. We'll call number n the size or the length of permutation p1,  p2,  ...,  pn.

We'll call position i (1 ≤ i ≤ n) in permutation p1, p2, ..., pn good, if |p[i] - i| = 1. Count the number of permutations of size n with exactly k good positions. Print the answer modulo 1000000007 (109 + 7).


Input

The single line contains two space-separated integers n and k (1 ≤ n ≤ 1000, 0 ≤ k ≤ n).

Output

Print the number of permutations of length n with exactly k good positions modulo 1000000007 (109 + 7).

Examples
Input
1 0
Output
1
Input
2 1
Output
0
Input
3 2
Output
4
Input
4 1
Output
6
Input
7 4
Output
328
Note

The only permutation of size 1 has 0 good positions.

Permutation (1, 2) has 0 good positions, and permutation (2, 1) has 2 positions.

Permutations of size 3:

  1. (1, 2, 3) — 0 positions
  2. — 2 positions
  3. — 2 positions
  4. — 2 positions
  5. — 2 positions
  6. (3, 2, 1) — 0 positions

题意:给定N,M,让你求有多少N的排列,使得|a[i]-i|==1的个数为M。

思路:用dp[i][j][now][next];表示前面i个有j个满足上述条件,而且第i为和第i+1位被占的情况位now和next。那么不难写出方程。

但是我写出代码后,发现(2,1)是错的,我输出2,答案是0;因为不可能只有1个在临位。那可以发现,现在是dp[N][M][now][next]*(N-j)!代表的结果是大于M的,还需要容斥。

容斥:dp[N][M]的贡献,减去dp[N][M+1]的贡献,加上...

可以发现,每一个好的位置有M+1个的排列,再算有j个的排列时都会被算M+1次(因为对于这个j+1排列,每一个好位置被无视掉以后都会构成一个j排列)

同理,每一个好的位置有j+2个的排列则会再算j个的排列时重复C(M+2,2)

.... 每一个好的位置有j个的排列会在算i(i < j)的排列时被计算C(M+j,M);

即dp[N][M+j]的系数C(M+j,M);

#include<bits/stdc++.h>
#define rep(i,a,b) for(int i=a;i<=b;i++)
using namespace std;
const int maxn=1010;
const int Mod=1e9+7;
int dp[maxn][maxn][2][2],fac[maxn],rev[maxn];
int qpow(int a,int x)
{
    int res=1; while(x){
        if(x&1) res=1LL*res*a%Mod;
        x>>=1; a=1LL*a*a%Mod;
    } return res;
}
int C(int N,int M) { return 1LL*fac[N]*rev[M]%Mod*rev[N-M]%Mod;}
int main()
{
    int N,M;
    scanf("%d%d",&N,&M);
    fac[0]=1; rev[0]=1;
    rep(i,1,N) fac[i]=1LL*fac[i-1]*i%Mod;
    rev[N]=qpow(fac[N],Mod-2);
    for(int i=N-1;i>=1;i--) rev[i]=1LL*rev[i+1]*(i+1)%Mod;
    dp[0][0][0][0]=1;
    rep(i,0,N-1) {
      rep(j,0,i){
        rep(p,0,1){
          rep(q,0,1){
              if(!dp[i][j][p][q]) continue;
              if(p==0&&i) (dp[i+1][j+1][q][0]+=dp[i][j][p][q])%=Mod; //i+1放左边
              (dp[i+1][j+1][q][1]+=dp[i][j][p][q])%=Mod; //放右边
              (dp[i+1][j][q][0]+=dp[i][j][p][q])%=Mod; //两边都不放
          }
        }
      }
    }
    int ans=0;
    rep(i,M,N){
        int tmp=1LL*(dp[N][i][1][0]+dp[N][i][0][0])%Mod*C(i,M)%Mod*fac[N-i]%Mod;
        if((i-M)%2==0) {
            ans+=tmp;
            if(ans>=Mod) ans-=Mod;
        }
        else{
           ans-=tmp;
           if(ans<0) ans+=Mod;
        }
    }
    printf("%d
",ans);
    return 0;
}
原文地址:https://www.cnblogs.com/hua-dong/p/10150535.html